//////////////////////////////////////////////////////////////////////////////////////////////////
events_Holder


	//============================================================================================
	proc
		//----------------------------------------------------------------------------------------
		//	Clear out all data involving Source.
		events_RemoveSource(Source)
			if ( isnull(Source) )
				return FALSE

			.	= FALSE

			var
				event
				trigger

			//	Remove events.
			for(trigger in src.events_events)
				for(event in src.events_events[trigger])
					if (Source in src.events_events[trigger][event])
						src.events_events[trigger][event]	-= Source
						.							= TRUE

						//	Clean up.
						if ( !length(src.events_events[trigger][event]) )
							src.events_events[trigger]		-= event
							if ( !length(src.events_events[trigger]) )
								src.events_events			-= trigger
								if ( !length(src.events_events) )
									src.events_events		= null

			var/trigger2

			//	Remove additions.
			for(trigger in src.events_adds)
				for(trigger2 in src.events_adds[trigger])
					for(event in src.events_adds[trigger][trigger2])
						if (Source in src.events_adds[trigger][trigger2][event])
							src.events_adds[trigger][trigger2][event]	-= Source
							.									= TRUE

							//	Clean up.
							if ( !length(src.events_adds[trigger][trigger2][event]) )
								src.events_adds[trigger][trigger2]		-= event
								if ( !length(src.events_adds[trigger][trigger2]) )
									src.events_adds[trigger]			-= trigger2
									if ( !length(src.events_adds[trigger]) )
										src.events_adds				-= trigger
										if ( !length(src.events_adds) )
											src.events_adds				= null

			//	Remove removals.
			for(trigger in src.events_removes)
				for(trigger2 in src.events_removes[trigger])
					for(event in src.events_removes[trigger][trigger2])
						if (Source in src.events_removes[trigger][trigger2][event])
							src.events_removes[trigger][trigger2][event]	-= Source
							.									= TRUE

							//	Clean up.
							if ( !length(src.events_removes[trigger][trigger2][event]) )
								src.events_removes[trigger][trigger2]		-= event
								if ( !length(src.events_removes[trigger][trigger2]) )
									src.events_removes[trigger]			-= trigger2
									if ( !length(src.events_removes[trigger]) )
										src.events_removes					-= trigger
										if ( !length(src.events_removes) )
											src.events_removes				= null

			return FALSE

//////////////////////////////////////////////////////////////////////////////////////////////////